/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */


Main();


/**
 * Fonction principale
 * Appelée au chargement de la page
 * 
 */
function Main()
{
    console.log("Main");

    // création du module AngularJS         
    var oModule = angular.module("AppliAngularJS", []);

    // déclaration des contrôleurs
    oModule.controller("MainControler", MainControler) 
      .controller("ViewControler", ViewControler)
      .factory('DataService', DataServiceFactory)
      .controller('oPromiseControler', PromiseControler);
}


/**
 * Création de la factory chargement des données
 * 
 * @param {[type]} $scope [description]
 */
function DataServiceFactory($q, $http) 
{
    var oCache = {};

    // création de l'objet service
    var oService =
    {
        data:{src:''},// init de l'objet résultat pour le controler
        getData: function(id, callback) 
        {
            var oPromise = $q.defer();// création de la promise

            // si les données sont dans le cache
            if (oCache[id])
            {
                oService.data.src='cache';// sources des données
                oPromise.resolve(oCache[id]);// résout la promise, la fait passer en état de succès
            }
            else
            {
                // récupération des données depuis le fichier json
                $http.get('data/data.json').then(function(oFileResult)// création d'une 2ème promise
                {
                    oCache[id] = oFileResult.data;// le contenu du fichier json
                    oService.data.src='ajax';// sources des données
                    oPromise.resolve(oCache[id]);// résout la promise, la fait passer en état de succès
                })
            }
            return oPromise.promise.then(callback);// retourne une nouvelle promise
        }
    }
    
    return oService;
} 




/**
 * Controler qui utilise la factory pour récupérer les données
 * 
 * @param {[type]} $scope [description]
 */
function PromiseControler($scope, DataService) 
{
    // appel lorsque l'utilisateur clique sur le bouton
    $scope.loadData = function()
    {
        DataService.getData(13, function(result)
        {
            $scope.data = result;// le contenu du fichier json - le retour de la promise résolue avec succès
            $scope.dataSource = DataService.data.src;
        });
    }
} 



/**
 * Déclaration des variables des vues
 * 
 * @param {[type]} $scope [description]
 */
function ViewControler($scope) 
{ 
    $scope.pageTitle = "Utilisation d'AngularJS"; 
} 
     

/**
 * Déclaration des variables nécessaires dans la zone gérée par AngularJS
 * 
 * @param {[type]} $scope [description]
 */
function MainControler($scope) 
{
    // représentation du modèle - les données
    $scope.user = { name: "Matthieu", site: "Développement Facile" }; 
    $scope.status = "banniere-cours-prog-facile-950";// affiche une image
    $scope.title = "Application Développement Facile"; 
} 
 
